// Alexandru Velea
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

const int kMaxN = 1e3+5;

int el[kMaxN][kMaxN];

struct Rectangle {
    int x, y, lx, ly;
    Rectangle() : x(0), y(0), lx(0), ly(0) { }
};

vector<Rectangle> rectangles;

void AddRectangle(int x, int y) {
    Rectangle r;
    r.x = x;
    r.y = y;

    while (el[x][y + r.ly] == 1) {
        r.ly += 1;
    }

    while (el[x + r.lx][y] == 1) {
        r.lx += 1;
    }

    rectangles.push_back(r);
}

int lazy_x[kMaxN];
int lazy_y[kMaxN];

int X[kMaxN];
int Y[kMaxN];

int main() {
    ifstream cin("arhipelag.in");
    ofstream cout("arhipelag.out");

    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i += 1) {
        for (int j = 1; j <= m; j += 1) {
            cin >> el[i][j];
        }
    }

    for (int i = 1; i <= n; i += 1) {
        for (int j = 1; j <= m; j += 1) {
            if (el[i][j] and el[i - 1][j] == 0 and el[i][j - 1] == 0) {
                AddRectangle(i, j);
            }
        }
    }

    int sum_x = 0, sum_y = 0;
    int lazy_x_sum = 0;
    int lazy_y_sum = 0;

    for (auto itr : rectangles) {
        lazy_x_sum -= 1;
        lazy_x[itr.x + 1] += 1;
        sum_x += itr.x;

        lazy_x[itr.x + itr.lx] += 1;

        lazy_y_sum -= 1;
        lazy_y[itr.y + 1] += 1;
        sum_y += itr.y;
        lazy_y[itr.y + itr.ly] += 1;
    }

    for (int i = 1; i <= n; i += 1) {
        lazy_x_sum += lazy_x[i];
        sum_x += lazy_x_sum;
        X[i] = sum_x;
    }

    for (int i = 1; i <= m; i += 1) {
        lazy_y_sum += lazy_y[i];
        sum_y += lazy_y_sum;
        Y[i] = sum_y;
    }

    int mn = 1e9;
    int rx = -1, ry = -1;
    for (int i = 1; i <= n; i += 1) {
        for (int j = 1; j <= m; j += 1) {
            if (el[i][j] == 1) {
                continue;
            }
            if (X[i] + Y[j] < mn) {
                mn = X[i] + Y[j];
                rx = i;
                ry = j;
            }
        }
    }

    cout << rx << ' ' << ry << '\n';
    return 0;
}
