// Alexandru Velea
#include <fstream>
#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

const int kMaxN = 1e3+5;

char el[kMaxN][kMaxN];

struct Rectangle {
    int x, y, lx, ly;
    Rectangle() : x(0), y(0), lx(0), ly(0) { }
};

vector<Rectangle> rectangles;

void AddRectangle(int x, int y) {
    Rectangle r;
    r.x = x;
    r.y = y;

    while (el[x][y + r.ly] == 1) {
        r.ly += 1;
    }

    while (el[x + r.lx][y] == 1) {
        r.lx += 1;
    }

    rectangles.push_back(r);
}

int Distance(int x, int y, int a, int b) {
    return abs(x - a) + abs(y - b);
}

int main() {
    ifstream cin("arhipelag.in");
    ofstream cout("arhipelag.out");

    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i += 1) {
        for (int j = 1; j <= m; j += 1) {
            cin >> el[i][j];
            el[i][j] -= '0';
        }
    }

    for (int i = 1; i <= n; i += 1) {
        for (int j = 1; j <= m; j += 1) {
            if (el[i][j] and el[i - 1][j] == 0 and el[i][j - 1] == 0) {
                AddRectangle(i, j);
            }
        }
    }

    int mn = 1e9;
    int rx = -1, ry = -1;
    for (int i = 1; i <= n; i += 1) {
        for (int j = 1; j <= m; j += 1) {
            if (el[i][j] == 1) {
                continue;
            }

            int sum = 0;
            for (auto r : rectangles) {
                int mn = 1e9;
                for (int x = 0; x < r.lx; x += 1) {
                    for (int y = 0; y < r.ly; y += 1) {
                        mn = min(mn, Distance(i, j, r.x + x, r.y + y));
                    }
                }

                sum += mn;
            }

            if (mn > sum) {
                mn = sum;
                rx = i;
                ry = j;
            }
        }
    }

    cout << rx << ' ' << ry << '\n';
    return 0;
}
