// Alexandru Velea
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

const int kMaxN = 1e3+5;

char el[kMaxN][kMaxN];

struct Rectangle {
    int x, y, lx, ly;
    Rectangle() : x(0), y(0), lx(0), ly(0) { }

    int DistanceX(int a) {
        int r = 0;
        if (x <= a and a < x + lx) {
        } else if (a < x) {
            r += x - a;
        } else {
            r += a - (x + lx - 1);
        }

        return r;
    }

    int DistanceY(int b) {
        int r = 0;
        if (y <= b and b < y + ly) {
        } else if (b < y) {
            r += y - b;
        } else {
            r += b - (y + ly - 1);
        }       

        return r;
    }
};

vector<Rectangle> rectangles;

void AddRectangle(int x, int y) {
    Rectangle r;
    r.x = x;
    r.y = y;

    while (el[x][y + r.ly] == 1) {
        r.ly += 1;
    }

    while (el[x + r.lx][y] == 1) {
        r.lx += 1;
    }

    rectangles.push_back(r);
}

int X[kMaxN], Y[kMaxN];

int main() {
    ifstream cin("arhipelag.in");
    ofstream cout("arhipelag.out");

    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i += 1) {
        for (int j = 1; j <= m; j += 1) {
            cin >> el[i][j];
            el[i][j] -= '0';
        }
    }

    for (int i = 1; i <= n; i += 1) {
        for (int j = 1; j <= m; j += 1) {
            if (el[i][j] and el[i - 1][j] == 0 and el[i][j - 1] == 0) {
                AddRectangle(i, j);
            }
        }
    }

    for (int i = 1; i <= n; i += 1) {
        for (auto r : rectangles) {
            X[i] += r.DistanceX(i);
        }
    }

     for (int i = 1; i <= m; i += 1) {
        for (auto r : rectangles) {
            Y[i] += r.DistanceY(i);
        }
    }   

    int mn = 1e9;
    int rx = -1, ry = -1;
    for (int i = 1; i <= n; i += 1) {
        for (int j = 1; j <= m; j += 1) {
            if (el[i][j] == 1) {
                continue;
            }
            if (X[i] + Y[j] < mn) {
                mn = X[i] + Y[j];
                rx = i;
                ry = j;
            }
        }
    }

    cout << rx << ' ' << ry << '\n';
    return 0;
}
