#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

int c, n, k;
vector<int> el;

void Solve1() {
    vector<bool> bits;
    for (auto itr : el) {
        int p = 30;
        for (; p >= 0; p -= 1) {
            if ((1 << p) & itr) {
                break;
            }
        }

        if (p == -1) {
            p = 0;
        }

        for (; p >= 0; p -= 1) {
            bits.push_back(!!((1 << p) & itr));
        }
    }
    
    ofstream cout("mirror.out");
    
    for (int i = 0; i + k <= (int)bits.size(); i += k) {
        int x = 0;
        for (int j = 0; j < k; j += 1) {
            x *= 2;
            x += bits[i + j];
        }
        
        cout << x << ' ';
    }
    cout << '\n';

    return;
}

void Mirror(int& a, int k) {
    int p = 30;
    for (; p >= 0; p -= 1) {
        if ((1 << p) & a) {
            break;
        }
    }

    if (p == -1) {
        p = 0;
    }

    vector<bool> bits;
    for (int i = 0; i <= p; i += 1) {
        bits.push_back(!!((1 << i) & a));
    }

    for (int i = 0; i < k and bits.size(); i += 1) {
        int last = bits.back();
        while (bits.size() and bits.back() == last) {
            bits.pop_back();
        }
    }

    k = k & 1;

    int x = 0;
    while (bits.size()) {
        x *= 2;
        x += k ^ bits.back();
        bits.pop_back();
    }

    a = x;
}

void Solve2() {
    int mx = -1;
    int where = 0;   

    vector<int> bits(31, 0);
    int right = 1;
    for (auto itr : el) {
        Mirror(itr, k);
        for (int p = 0; p <= 30; p++) {
            if ((1 << p) & itr) {
                bits[p]++;
                if (bits[p] > mx) {
                    mx = bits[p];
                    where = right;
                }
            } else {
                bits[p] = 0;
            }
        }

        right++;
    }

    ofstream cout("mirror.out");

    cout << mx << '\n';
    cout << where - mx + 1 << ' ' << where << '\n';

    return;
}

int main() {
    ifstream cin("mirror.in");
    cin >> c >> n >> k;
    el.resize(n);
    for (int i = 0; i < n; i += 1) {
        cin >> el[i];
    }

    if (c == 1) {
        Solve1();
    } else {
        Solve2();
    }

    return 0;
}
