// Alexandru Velea

#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;

typedef long long int64;

string AddStuffAtEnd(string start, vector<int> initial_digits, vector<int> final_digits) {
    for (int i = 0; i < 10; i += 1) {
        final_digits[i] -= initial_digits[i];
    }

    for (int i = 0; i < 10; i += 1) {
        for (int j = 0; j < final_digits[i]; j += 1) {
            start += char('0' + i);
        }
    }

    return start;
}

vector<int> ans;

bool IsOk(vector<int> digits, int k, int p) {
    sort(digits.begin(), digits.end());
    reverse(digits.begin(), digits.end());

    for (int i = 0; i + 1 < p; i += 1) {
        k -= digits[i];
    }

    if (k > 0) {
        return true;
    } else {
        return false;
    }
}

bool Possible(vector<int> digits, int k, int p, int remaining) {
    for (int i = 0; i < remaining; i += 1) {    
        (*(min_element(digits.begin(), digits.end())))++;
    }

    return IsOk(digits, k, p);
}

void SolveThis(vector<int> digits, int digit, int k, int p, int remaining, bool& ok) {
    if (digit == 10) {
        if (remaining != 0) {
            return;
        }

        ok = true;
        ans = digits;
        return ;
    }

    for (int current = remaining; current >= 0; current -= 1) {
        digits[digit] += current;   
        if (Possible(digits, k, p, remaining - current)) {
            SolveThis(digits, digit + 1, k, p, remaining - current, ok);
            auto d = digits;
            if (ok) {
                return;
            } else {
            }
        }
        digits[digit] -= current;   
    }

    return;
}

void SolveFixed(vector<int> digits, int last_digit, int k, int p, int remaining, bool& ok, int& digit) {
    for (int current_digit = last_digit + 1; current_digit < 10; current_digit += 1) {
        digits[current_digit] += 1;
        SolveThis(digits, 0, k, p, remaining - 1, ok);
        digits[current_digit] -= 1;

        if (ok) {
            digit = current_digit;
            return;
        }
    }

    return;
}

string Solve(int k, int p, string n) {
    vector<int> digits(10, 0);
    for (char itr : n) {
        digits[itr - '0'] += 1;
    }

    if (IsOk(digits, k, p)) {
        return n;
    }

    int to_match = 0;
    while (n.size()) {
        to_match += 1;
        digits[n.back() - '0'] -= 1;
        bool ok = false;
        int digit = 0;
        SolveFixed(digits, n.back() - '0', k, p, to_match, ok, digit);
        n.pop_back();

        if (ok) {
            digits[digit] += 1;
            n += char('0' + digit);
            return AddStuffAtEnd(n, digits, ans);
        }
    }

    digits = vector<int>(10, 0);
    digits[1] += 1;

    bool ok = false;
    int digit = 0;
    SolveFixed(digits, -1, k, p, to_match, ok, digit);

    if (ok) {
        digits[digit] += 1;
        n = "1";
        n += char('0' + digit);
        return AddStuffAtEnd(n, digits, ans);
    } else {
        return "-1";
    }
}

bool IsOk(int64 n, int k, int p) {
    vector<int> digits(10, 0);
    do {
        digits[n % 10]++;
        n /= 10;
    } while (n);

    return IsOk(digits, k, p);
}

int Solve1(int k, int p, int64 left, int64 right) {
    int a = 0;
    for (int64 i = left; i <= right; i += 1) {
        a += IsOk(i, k, p);
    }

    return a;
}

int main() {
	freopen("okcpp.in", "r", stdin);
	freopen("okcpp.out", "w", stdout);

    int c;
    cin >> c;

    if (c == 2) {
        int k, p;
        string n;
        cin >> k >> p >> n;
        cout << Solve(k, p, n) << '\n';
    } else {
        int k, p;
        int64 left, right;
        cin >> k >> p >> left >> right;
        cout << Solve1(k, p, left, right) << '\n';
    }

    return 0;
}
