// Problema Orase - Oni clasa a 9-a
// sursa Velea Alexandru
// time O(n + max_distance * x + max_distance * max_speed)
// Rezolvare pentru tipul de restrictii 3
// 15 points
#include <cassert>
#include <cmath>

#include <iomanip>
#include <fstream>
#include <iostream>
#include <queue>
#include <vector>
using namespace std;

typedef long long int64;

const int kMaxDistance = 201, kMaxSpeed = 1001;

struct Road {
    int distance;
    int speed;
    int id;

    long double SavedTime(int bonus_time = 0) const {
        return 1.0 * distance / (speed + bonus_time) / (speed + 1 + bonus_time);
    }

    long double Time(int bonus_time = 0) const {
        return 1.0 * distance / (speed + bonus_time);
    }

    bool operator<(const Road& rhs) const {
        return SavedTime() < rhs.SavedTime();
    }
};

int64 x;
vector<Road> roads;

int Read() {
    ifstream cin("orase.in");
    int test_type;
    cin >> test_type;

    int n;
    cin >> n >> x;

    roads.resize(n);

    for (int i = 0; i < n; i += 1) {
        roads[i].id = i;
    }

    for (auto& itr : roads) {
        cin >> itr.distance;
    }

    for (auto& itr : roads) {
        cin >> itr.speed;
    }

    return 1;
}

int is_read = Read();


int num_roads[kMaxDistance][kMaxSpeed];
int mn_speed[kMaxDistance + 1];

long double SavedTime(int distance, int speed) {
    return 1.0 * distance / (speed) / (speed + 1);
}

long double Time(int distance, int speed) {
    return 1.0 * distance / (speed);
}

long double Solve() {
    for (auto itr : roads) {
        num_roads[itr.distance][itr.speed] += 1;
    }

    for (int i = 0; i < kMaxDistance; i += 1) {
        while (mn_speed[i] < kMaxSpeed + 1 and num_roads[i][mn_speed[i]] == 0) {
            mn_speed[i] += 1;   
        }
    }

    while (x--) {
        long double mx_save = 0;
        int where = 0;
        for (int dist = 1; dist < kMaxDistance; dist += 1) {
            if (num_roads[dist][mn_speed[dist]] == 0) {
                continue;
            }

            if (SavedTime(dist, mn_speed[dist]) > mx_save) {
                mx_save = SavedTime(dist, mn_speed[dist]);
                where = dist;
            }
        }

        num_roads[where][mn_speed[where]] -= 1;
        num_roads[where][mn_speed[where] + 1] += 1;

        if (num_roads[where][mn_speed[where]] == 0) {
            mn_speed[where] += 1;
        }

        if (mn_speed[where] == kMaxSpeed - 2) {
            assert(0);
        }
    }

    long double ans = 0;

    for (int dist = 1; dist < kMaxDistance; dist += 1) {
        for (int speed = 1; speed < kMaxSpeed; speed += 1) {
            ans += Time(dist, speed) * num_roads[dist][speed];
        }
    }

    return ans;
}

int main() {
    long double answer = Solve();

    ofstream cout("orase.out");
    cout << int64(answer) << '\n';

    return 0;
}
