// Problema Orase - Oni clasa a 9-a
// sursa Velea Alexandru
// restrictiile 1 si 2
// time O(N * X)
// 30 points

#include <cmath>

#include <iomanip>
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

typedef long long int64;

struct Road {
    int distance;
    int speed;
    int id;

    long double SavedTime(int bonus_time = 0) const {
        return 1.0 * distance / (speed + bonus_time) / (speed + 1 + bonus_time);
    }

    long double Time(int bonus_time = 0) const {
        return 1.0 * distance / (speed + bonus_time);
    }

    bool operator<(const Road& rhs) const {
        return SavedTime() < rhs.SavedTime();
    }
};

int64 x;
vector<Road> roads;

int Read() {
    ifstream cin("orase.in");
    int test_type;
    cin >> test_type;

    int n;
    cin >> n >> x;

    roads.resize(n);

    for (int i = 0; i < n; i += 1) {
        roads[i].id = i;
    }

    for (auto& itr : roads) {
        cin >> itr.distance;
    }

    for (auto& itr : roads) {
        cin >> itr.speed;
    }

    return 1;
}

int is_read = Read();

long double Solve() {
    for (int i = 0; i < x; i += 1) {
        long double mx_save = roads[0].SavedTime();
        int where = 0;
    
        for (auto& itr : roads) {
            if (itr.SavedTime() > mx_save) {
                mx_save = itr.SavedTime();
                where = itr.id;
            }
        }

        roads[where].speed += 1;
    }

    long double answer = 0;
    for (auto& itr : roads) {
        answer += itr.Time();
    }	

    return answer;
}

int main() {
    long double answer = Solve();

    ofstream cout("orase.out");
	cout << int64(answer) << '\n';

    return 0;
}
