// Problema Orase - Oni clasa a 9-a
// sursa Velea Alexandru
// time O(N * log(X))
// Rezolvare pentru tipul de restrictii 4
// 20 points

#include <cmath>

#include <iomanip>
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

typedef long long int64;

struct Road {
    int distance;
    int speed;
    int id;

    long double SavedTime(int bonus_time = 0) const {
        return 1.0 * distance / (speed + bonus_time) / (speed + 1 + bonus_time);
    }

    long double Time(int bonus_time = 0) const {
        return 1.0 * distance / (speed + bonus_time);
    }

    bool operator<(const Road& rhs) const {
        return SavedTime() < rhs.SavedTime();
    }
};

int64 x;
vector<Road> roads;

int Read() {
    ifstream cin("orase.in");
    int test_type;
    cin >> test_type;

    int n;
    cin >> n >> x;

    roads.resize(n);

    for (int i = 0; i < n; i += 1) {
        roads[i].id = i;
    }

    for (auto& itr : roads) {
        cin >> itr.distance;
    }

    for (auto& itr : roads) {
        cin >> itr.speed;
    }

    return 1;
}

int is_read = Read();

vector<int64> GetUpgrades(int speed) {
    vector<int64> upgrades(roads.size(), 0);
    int n = (int)roads.size();

    for (int i = 0; i < n; i += 1) {
        if (roads[i].speed < speed) {
            upgrades[i] = speed - roads[i].speed;
        }
    }

    return upgrades;
}

int64 Count(int speed) {
    auto upgrades = GetUpgrades(speed);
    int64 sum = 0;
    for (auto itr : upgrades) {
        sum += itr;
    }

    return sum;
}

long double SameDistance() {
    int n = (int)roads.size();

    int speed = 0;
    for (int p = 28; p >= 0; p -= 1) {
        int64 c = Count(speed + (1 << p));

        if (c <= x) {
            speed += (1 << p);
        }
    }

    auto upgrades = GetUpgrades(speed);
    int sum = 0;
    for (int i = 0; i < n; i += 1) {
        roads[i].speed += upgrades[i];
        sum += upgrades[i];
    }

    x -= sum;
    for (int i = 0; i < n; i += 1) {
        if (roads[i].speed == speed and x) {
            x -= 1;
            roads[i].speed += 1;
        }
    }

    long double answer = 0.0;
    for (auto itr : roads) {
        answer += itr.Time();
    }

    return answer;
}

int main() {
    long double answer = SameDistance();

    ofstream cout("orase.out");
    cout << int64(answer) << '\n';
    return 0;
}
