// Problema Orase - Oni clasa a 9-a
// sursa Velea Alexandru
// time O(max_distance)
// Rezolvare pentru tipul de restrictii 4
// 20 points

#include <cassert>
#include <cmath>

#include <iomanip>
#include <fstream>
#include <iostream>
#include <queue>
#include <vector>
using namespace std;

typedef long long int64;

struct Road {
    int distance;
    int speed;
    int id;

    long double SavedTime(int bonus_time = 0) const {
        return 1.0 * distance / (speed + bonus_time) / (speed + 1 + bonus_time);
    }

    long double Time(int bonus_time = 0) const {
        return 1.0 * distance / (speed + bonus_time);
    }

    bool operator<(const Road& rhs) const {
        return SavedTime() < rhs.SavedTime();
    }
};

int64 x;
vector<Road> roads;

int Read() {
    ifstream cin("orase.in");
    int test_type;
    cin >> test_type;

    int n;
    cin >> n >> x;

    roads.resize(n);

    for (int i = 0; i < n; i += 1) {
        roads[i].id = i;
    }

    for (auto& itr : roads) {
        cin >> itr.distance;
    }

    for (auto& itr : roads) {
        cin >> itr.speed;
    }

    return 1;
}

int is_read = Read();

int speeds[(int)1e5];

long double Solve() {
    int n = roads.size();
    long double answer = 0;
    int distance = roads[0].distance;
    for (auto road : roads) {
        speeds[road.speed] += 1;    
    }

    bool same_speed = false;
    int speed = 0;

    for (int i = 1; i <= 1e4; i += 1) {
        if (speeds[i] == n) {
            same_speed = true;
            speed = i;
            break;
        }

        if (speeds[i] > x) {
            speeds[i] -= x;
            speeds[i + 1] += x;
            x = 0;
            break;
        } else {
            speeds[i + 1] += speeds[i];
            x -= speeds[i];
            speeds[i] = 0;
        }
    }

    if (x == 0) {
        for (int i = 1; i <= 1e5; i += 1) {
            answer += speeds[i] * (1.0 * distance / i);
        }

        return answer;
    }

    if (same_speed) {
        int num_upgrades = x / n;

        speed += num_upgrades;
        x -= num_upgrades * n;

        int next_speed = x;
        int current_speed = n - x;
        
        answer += current_speed * (1.0 * distance / speed);
        answer += next_speed * (1.0 * distance / (speed + 1));

        return answer;
    }
    
    return 0.0;
}

int main() {
    long double answer = Solve();

    ofstream cout("orase.out");
    cout << int64(answer) << '\n';

    return 0;
}
